import { CreateTaskRejectReasonRequest, PatchTaskRejectReasonRequest, TaskRejectReasonResponse, UpdateTaskRejectReasonRequest } from '@bringg/types';
import { CommonOptions } from '../../Core/RouteGenerator';
import { DataEntity, DataOptions, StorableItemMapper } from '../../data-entity';
import Session from '../../Services/Identity/Session';
export default class TaskRejectReasonsApi<T extends DataEntity> {
    private readonly taskRejectReasonsStore;
    private readonly taskRejectReasonsService;
    private readonly storableDataService;
    constructor(session: Session, mapper: StorableItemMapper<T, TaskRejectReasonResponse>);
    loadAll(options?: DataOptions): Promise<T[]>;
    delete(id: number, commonOption?: CommonOptions): Promise<void>;
    update(id: number, taskRejectReason: UpdateTaskRejectReasonRequest, commonOption?: CommonOptions): Promise<T>;
    patch(id: number, taskRejectReason: PatchTaskRejectReasonRequest, commonOption?: CommonOptions): Promise<T>;
    create(taskRejectReason: CreateTaskRejectReasonRequest, commonOption?: CommonOptions): Promise<T>;
    get(id: number): T;
    getAll(): T[];
    removeAll(): void;
}
